import java.util.ArrayList;
import java.util.Iterator;

import java.awt.Frame;
import java.awt.Graphics;


public class Graph{

	ArrayList knoten;		// Graph besitzt alle seine Knoten
	Agenda agenda;			// unsere Agenda
	
	String modus;			// Welchen Agendatyp verwenden?

	Knoten start, ziel;		// Start- und Zielknoten
	boolean amZiel;			// Ziel erreicht - Flag
	boolean agendaLeer;		// Suche hat keinen Sinn mehr - Flag
	Weg aktuellerWeg;		// Weg als Ergebnis nach aussen liefern

	Log logger;				// Dem Objekt schicken wir unsere Text-Erklrungen
	
	// Konstruktor
	public Graph(){
		knoten = new ArrayList();
		modus="TS";			// Tiefensuche
		
		amZiel = false;
		agendaLeer = false;

		logger = null;
	}
	
	// Logger setzen
	public void setzeLogger(Log l){
		logger = l;
	}
	
	// String an den Logger schicken
	public void log(String s){
		if(logger != null)
			logger.log(s);
	}
	
	// Agenda auswhlen: TS, BS
	public void setzeAgendaModus(String s){
		modus=s;
	}
	
	// in Abhngigkeit von modus ein neues Agenda-Objekt liefern
	private Agenda neueAgenda(){
	
		//System.out.println("Modus: "+modus);
	
		if(modus.equals("BS")) return new BSAgenda();
		
		return new Agenda();
	}
	
	
	// Knoten in den Graph einfgen
	public void fuegeKnotenEin(Knoten k){
		// Wenn der Knoten 'neu' ist
		if(!knoten.contains(k)){
			// fgen wir ihn in den Graphen ein
			knoten.add(k);
		}
	}
	
	// liefert den ersten gefundenen Weg, oder den leeren Weg, falls keine Lsg.
	public Weg suche1(Knoten start, Knoten ziel){
		// leere Agenda
		agenda = neueAgenda();
		// Startknoten als Weg in die Agenda einfgen
		agenda.fuegeWegEin(new Weg(start));
		//
		try{
		for(;;){
			// Agenda ausgeben
			// agenda.print();
			// Agenda leer?
			if(agenda.bistDuLeer()){
				// leeren Ergebnisweg liefern
				return new Weg();
			}
			// ersten Weg aus der Agenda lschen und liefern
			Weg w = agenda.liefereErstenWeg();
			// Ziel erreicht?
			if (w.endestDuIn(ziel)){
				// Ergebnisweg liefern!
				return w;
			}
			// Ziel nicht erreicht
			else{
				// Weg expandieren und neue Wege in die Agenda einfgen
				agenda.fuegeWegeEin(w.expandiere());
			}
			
		}
		}catch(AgendaEmptyException e){
				System.out.println("Agenda ist leer!");
				// leeren Ergebnisweg liefern
				return new Weg();
		}
	}
	
	
	// Scuhe initialisieren
	public void initialisiereSuche(Knoten s, Knoten z){
		// leere Agenda in Abhngigkeit von modus (TS, BS)
		agenda = neueAgenda();
		// System.out.println("neue Agenda: "+agenda);
		// Start- und Zielknoten merken
		start = s;
		ziel = z;	
		// Agenda mit Startknoten als Weg initialisieren
		agenda.fuegeWegEin(new Weg(start));
		log("Startknoten als Weg in die Agenda aufgenommen.\n");
		log("Agenda: "+agenda.toString());
		// aktueller Weg ist leer
		aktuellerWeg = new Weg();
		// log("\nAktueller Weg: "+aktuellerWeg.toString());
		log("\n");
		agendaLeer = false;
	}
	
	// Einen Schritt ausfhren
	public void fuehreNaechstenSuchSchrittAus(){
		try{
			log("aktuelle Agenda: "+agenda.toString());
			// log("\nAktueller Weg: "+aktuellerWeg.toString());
			
		
			if(agenda.bistDuLeer()){
				agendaLeer = true;
				log("\nAgenda ist leer!");
				return;
			}
			// ersten Weg aus der Agenda lschen und liefern
			Weg w = agenda.liefereErstenWeg();
			log("\nHole ersten Weg aus der Agenda: ");
			// w auch fr Abfrage durch Controller speichern
			aktuellerWeg = w;
			log(w.toString()+" .");
			// Ziel erreicht?
			if (w.endestDuIn(ziel)){
				// Flagge setzen
				amZiel = true;
				log("\nErster Weg der Agenda erreicht Ziel.\n");
				// System.out.println(agenda.toString());
				return;
			}
			// Ziel nicht erreicht
			else{
				log("\nErster Weg der Agenda erreicht das Ziel nicht.\n"+
					"(Bzw. weitere Lsung gefordert.)");
				// Weg expandieren und neue Wege in die Agenda einfgen
				log("\nDeshalb expandiere "+w.toString()+" .");
				agenda.fuegeWegeEin(w.expandiere());
				log("\nDer Weg "+w.toString()+" wurde aus der Agenda gelscht, \n"
					+"alle seine Expansionen (mgl. 0) wurden in die"+
					"\nAgenda eingefgt.");
				log("\nDie neue Agenda lautet: "+agenda.toString()+" .");
				log("\n-----------\n");
			}
		}catch(AgendaEmptyException e){
			System.err.println(e);
			System.exit(1);
		}
	}

	// Flagge zurcksetzen 
	// Der letzte erfolgreiche Weg ist sowieso nicht mehr in der Agenda!
	public void initialisiereNaechsteLoesung(){
		// wir sind also doch nicht am Ziel...
		amZiel = false;
		// aktuellerWeg ndern??
	}
	
	
	// von aussen fragen, ob die Agenda leer und die Suche
	// damit definitiv zuende ist 
	public boolean istAgendaLeer(){
		return agendaLeer;
	}	
	
	// von aussen fragen, ob der Zielknoten erreicht wurde
	public boolean istZielErreicht(){
		return amZiel;	
	}	
	
	// von aussen aktuellen Weg besorgen (z.B. fr Ausgabe)
	public Weg  aktuellerWeg(){
		return aktuellerWeg;
	}
	
	// Start und Ziel von aussen abrufbar machen
	public Knoten zielKnoten(){
		return ziel;
	}
	public Knoten startKnoten(){
		return start;
	}
	

	// Iterator ber alle Knoten liefern (zum Zeichnen)
	public Iterator alleKnoten(){
		return knoten.iterator();
	}


	// Knotenobjekt gegen einen Namen herausrcken
	public Knoten KnotenGegenName(String s){
		Iterator i = alleKnoten();
		while(i.hasNext()){
			Knoten knoten = (Knoten)i.next();
			if(s.equals(knoten.name)) return knoten;
		}
		return new Knoten("NIX!",-9,-9);
	}

	public static void main(String[] Args){
		System.out.println("Suchdemo1");
		

		Knoten[] k = new Knoten[8];
		// Knoten		
		k[0] = new Knoten("a",30,40);
		k[1] = new Knoten("b",10,60);
		k[2] = new Knoten("c",70,80);
		k[3] = new Knoten("d",90,80);
		k[4] = new Knoten("e",50,120);
		k[5] = new Knoten("f",20,130);
		k[6] = new Knoten("g",60,180);
		k[7] = new Knoten("h",110,180);
		// Nachfolger
		k[0].fuegeNachfolgerHinzu(k[1]);
		k[0].fuegeNachfolgerHinzu(k[3]);
		k[1].fuegeNachfolgerHinzu(k[2]);
		k[1].fuegeNachfolgerHinzu(k[4]);
		k[2].fuegeNachfolgerHinzu(k[5]);
		k[2].fuegeNachfolgerHinzu(k[7]);
		k[3].fuegeNachfolgerHinzu(k[6]);
		k[4].fuegeNachfolgerHinzu(k[2]);														
		k[5].fuegeNachfolgerHinzu(k[7]);
		k[6].fuegeNachfolgerHinzu(k[1]);
		k[6].fuegeNachfolgerHinzu(k[4]);
		k[7].fuegeNachfolgerHinzu(k[2]);
		// Graphen anlegen
		Graph g = new Graph();
		// Knoten ausgeben und in Graphen einhngen		
		for(int i = 0; i<k.length; i++){
			System.out.print(k[i].name +" "+ k[i].x +" "+ k[i].y +" ");
			Iterator n = k[i].nachfolgerListe();
			while(n.hasNext()){
				Knoten knoten = (Knoten)n.next();
				System.out.print(knoten.name+" ");
			}
			System.out.println(" ");
			// Knoten in Graph g einhngen
			g.fuegeKnotenEin(k[i]);	
		}
		
		
		System.out.println("Suche:");
		// Suche starten
	
		//	g.suche(k[0],k[0]);
			g.setzeAgendaModus("TS");
			Weg w = g.suche1(k[0],k[7]);
			System.out.println("Der Weg zum Ziel (TS):");
			w.print();
			
			g.setzeAgendaModus("BS");
			w = g.suche1(k[0],k[7]);
			System.out.println("Der Weg zum Ziel (BS):");
			w.print();
			
			
		//g.suche(k[0],new Knoten("bla",0,0));			
			
		

	}
	
	
	

}
