import java.util.Iterator;

import java.awt.Frame;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Button;
import java.awt.TextArea;
import java.awt.Choice;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.Label;
import java.awt.Dialog;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;


public class GraphWindow extends Frame implements ActionListener, Log{

	// Dialogfenster
	public class GraphDialog extends Dialog implements ActionListener{
		
		Choice c1,c2,c3;
		
		// Modaler Dialog zur Abfrage der Suchparameter
		public GraphDialog(Frame owner, Graph g){
			super(owner, "Neue Suche", true);
			
			Iterator alleKnoten = g.alleKnoten();
			
			Label l1 = new Label("Suchstrategie");
			c1 = new Choice();
			c1.add("Tiefensuche");
			c1.add("Breitensuche");			
			
			Label l2 = new Label("Startknoten");
			c2 = new Choice();
			Label l3 = new Label("Zielknoten");
			c3 = new Choice();
			
			while(alleKnoten.hasNext()){
				Knoten k = (Knoten)alleKnoten.next();
				c2.add(k.name);
				c3.add(k.name);				
			}
			
			Panel p = new Panel(new GridLayout(3,2));
			p.add(l1);
			p.add(c1);
			p.add(l2);
			p.add(c2);
			p.add(l3);
			p.add(c3);

			Button ok = new Button("OK");

			setLayout(new BorderLayout());
			add("Center",p);
			add("South", ok);

			ok.addActionListener(this);

			pack();
			setVisible(true);
		}
	
	
		public void actionPerformed(ActionEvent event){
			System.out.println(event);
			if(event.getActionCommand().equals("OK")){
				if(c1.getSelectedItem().equals("Tiefensuche"))
					g.setzeAgendaModus("TS");
				if(c1.getSelectedItem().equals("Breitensuche"))
					g.setzeAgendaModus("BS");

				Knoten s,z;
				s = g.KnotenGegenName(c2.getSelectedItem());
				z = g.KnotenGegenName(c3.getSelectedItem());				
			
				
				g.initialisiereSuche(s,z);
			//	log(c1.getSelectedItem()+" von "+c2.getSelectedItem()+
			//	" nach "+c3.getSelectedItem()+" initialisiert. \n");
				
				
				// Modaldialog wegrumen
				setVisible(false);
				// muss man wohl machen...
				// g.fuehreNaechstenSuchSchrittAus();
			
				gv.markiereStartZiel(s,z);
				gv.setzeWeg(new Weg()); // gv.aktuellerWeg leeren...

				dispose();
			}


		}
	
	}

	// Membervariablen
	
	GraphView gv;
	Graph g;
	TextArea log;
	boolean initialisiert;
	
	// Konstruktor
	public GraphWindow(Graph graph, GraphView gview){
	
		super("Demonstration von Graphensuchalgorithmen");
	
		gv = gview;
		g = graph;
		initialisiert = false;
	
		// Men
		Menu m = new Menu("Demo");
		m.add(new MenuItem("Neue Suche"));
		m.addActionListener(this);
		m.addSeparator();
		m.add(new MenuItem("Beenden"));
		// Menzeile	
		MenuBar menubar = new MenuBar();
		menubar.add(m);
		setMenuBar(menubar);
		// Menzeile ins Fenster packen
		setLayout(new BorderLayout());
		
		Button schritt = new Button("nchster Schritt");
		schritt.addActionListener(this);
		add("North",schritt);
	
		log = new TextArea(10,60);
		add("South", log);
		
		add("Center", gv);
		
		
		
		// Close-Knopf aktivieren
		addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					setVisible(false);
					dispose();
					System.exit(0);
				}
			}
		);
		
		
		setSize(640,480);
		setVisible(true);
	
	}
	

	public void actionPerformed(ActionEvent event){
		System.out.println(event);
		
		if(event.getActionCommand().equals("Neue Suche")){
			new GraphDialog(this, g);	
			gv.repaint();
			initialisiert = true;				
		}
	
		else if(event.getActionCommand().equals("Beenden")){
			System.exit(0);
		}
	
		else if(event.getActionCommand().equals("nchster Schritt")){
			if(!initialisiert){
				log("\nStarten Sie eine neue Suche!\n");
				new GraphDialog(this, g);
				initialisiert = true;
				gv.repaint();
				return;
			}
			
			// nchsten Schritt ausfhren!

			// solange die Agenda nicht leer ist
			if(g.istAgendaLeer()){
				log("\nDie Agenda ist leer, die Suche ist erschpft.\n"+
					"Starten Sie eine neue Suche!\n\n");
				initialisiert=false;
				return;
			}

			// Einen Schritt ausfhren
			g.fuehreNaechstenSuchSchrittAus();
			
			// Fr die Grafikausgabe:			
			gv.setzeWeg(g.aktuellerWeg());
			gv.repaint();
			
			// prfen, ob am Ziel
			if(g.istZielErreicht()){
				//log("Ziel erreicht. Der Weg lautet: ");
				//log(g.aktuellerWeg().toString());
				//log("\n");
				
				// g.aktuellerWeg().print();
				//gv.setzeWeg(g.aktuellerWeg());
				//gv.repaint(); // machen wir schon weiter oben
			
				// Wir wollen alle Lsungen!
				g.initialisiereNaechsteLoesung();
				return;
			}
			

			// aktuellen Weg anzeigen (Text)
//			System.out.print("   aktueller Weg:");			
//			g.aktuellerWeg().print();
			System.out.println(" ");						
		//
			
		
		//
			
		}

	
	}
	
	

	public void log(String s){
		log.append(s);
	
	}

	public static void main(String[] Args){
	
		int xm = 4;
		int ym = 3;
	
		Knoten[] k = new Knoten[14];
		// Knoten		
		k[0] = new Knoten("a",15*xm,20*ym);
		k[1] = new Knoten("b",10*xm,40*ym);
		k[2] = new Knoten("c",13*xm,68*ym);
		k[3] = new Knoten("d",24*xm,57*ym);
		k[4] = new Knoten("e",40*xm,42*ym);
		k[5] = new Knoten("f",47*xm,18*ym);
		k[6] = new Knoten("g",60*xm,39*ym);
		k[7] = new Knoten("h",52*xm,60*ym);
		k[8] = new Knoten("i",50*xm,75*ym);
		k[9] = new Knoten("j",75*xm,48*ym);
		k[10] = new Knoten("k",78*xm,66*ym);
		k[11] = new Knoten("l",84*xm,30*ym);
		k[12] = new Knoten("m",100*xm,16*ym);
		k[13] = new Knoten("n",97*xm,37*ym);

		
		// Nachfolger
		k[0].fuegeNachfolgerHinzu(k[1]);
		k[0].fuegeNachfolgerHinzu(k[4]);		
		k[1].fuegeNachfolgerHinzu(k[4]);
		k[1].fuegeNachfolgerHinzu(k[3]);
		k[2].fuegeNachfolgerHinzu(k[3]);
		k[3].fuegeNachfolgerHinzu(k[4]);								
		k[3].fuegeNachfolgerHinzu(k[8]);
		k[4].fuegeNachfolgerHinzu(k[7]);		
		k[5].fuegeNachfolgerHinzu(k[6]);
		k[6].fuegeNachfolgerHinzu(k[7]);
		k[6].fuegeNachfolgerHinzu(k[11]);
		k[7].fuegeNachfolgerHinzu(k[8]);								
		k[7].fuegeNachfolgerHinzu(k[9]);
		k[7].fuegeNachfolgerHinzu(k[10]);		
		k[9].fuegeNachfolgerHinzu(k[10]);
		k[10].fuegeNachfolgerHinzu(k[13]);
		k[11].fuegeNachfolgerHinzu(k[12]);
		k[11].fuegeNachfolgerHinzu(k[13]);								
		
		
		
		// Graphen anlegen
		Graph g = new Graph();
		// Knoten in Graphen einhngen		
		for(int i = 0; i<k.length; i++){
			Iterator n = k[i].nachfolgerListe();
			while(n.hasNext()){
				Knoten knoten = (Knoten)n.next();
			}
			g.fuegeKnotenEin(k[i]);	
		}
		

		
		//new Weg(k[0])
		GraphView gv = new GraphView(g.alleKnoten(),k[0],k[0],new Weg(k[0]));
		GraphWindow gw = new GraphWindow(g,gv);
		g.setzeLogger(gw);
		
		
	}

}
